View Issue Details

IDProjectCategoryView StatusLast Update
0000515Pgpool-IIBugpublic2019-08-15 16:56
ReporterstaslgAssigned Tot-ishii 
PrioritynormalSeveritymajorReproducibilityalways
Status feedbackResolutionreopened 
Platformx86_64OSCentOS Linux release 7.6.1810 OS Version7.6
Product Version4.0.5 
Target VersionFixed in Version 
Summary0000515: Pgpool node status waiting
DescriptionHi

I have a question about node status:
Very often I see status waiting and I understand that failover do not work

But if I check file status I see that status is up for all nodes:
postgres@db-balanser$ cat /var/log/pgpool-II-10/pgpool_status
up
up

If I make command for pcp_attach waiting node status do not changed

How to fix this bug ?
Steps To Reproducepostgres@db-balanser$ psql -U pgpool -p 9999 --host sso-db-balanser --dbname postgres -c "show pool_nodes"
 node_id | hostname | port | status | lb_weight | role | select_cnt | load_balance_node | replication_delay | last_status_change
---------+----------+------+---------+-----------+--------+------------+-------------------+-------------------+---------------------
 0 | db1 | 5432 | up | 0.500000 | master | 0 | true | 0 | 2019-05-21 06:37:52
 1 | db2 | 5432 | waiting | 0.500000 | slave | 0 | false | 0 | 2019-05-21 06:38:05

repmgr status

 ID | Name | Role | Status | Upstream | Location | Priority | Connection string
----+-------+---------+-----------+----------+----------+----------+--------------------------------------------------
 1 | node1 | primary | * running | | default | 100 | host=db1 port=5432 user=repmgr dbname=repmgr
 2 | node2 | standby | running | node1 | default | 100 | host=db2 port=5432 user=repmgr dbname=repmgr




TagsNo tags attached.

Activities

t-ishii

2019-05-21 13:28

developer   ~0002610

"waiting" can be safely assumed same as "up". "Waiting" means the PostgreSQL server is up and running but has not been connected from Pgpool-II yet. So once a client connects to Pgpool-II, it connects to PostgreSQL and the status will be turned to "up".

staslg

2019-05-21 13:50

reporter   ~0002611

Thanks for your answer, today I will check again

staslg

2019-05-23 14:03

reporter   ~0002629

Thanks
The ticket can be closed.

staslg

2019-05-28 13:13

reporter   ~0002639

Hi again
We check again failover today and it dose not work :(

Firstly we checked status Node0 and Node1, all in up status
When we shutdown node0, failover stared and promot to node1 - repmgr work correctly
But pgpool shows status waiting to node1 and connection refused

Check status pgpool:
psql -U pgpool -p 9999 --host db-bln-stg --dbname postgres -c "show pool_nodes"
psql: FATAL: failed to create a backend connection
DETAIL: executing failover on backend

Check status nodes:
db0 5432 3 0.500000 down master 0 2019-05-28 06:57:54
db1 5432 1 0.500000 waiting slave 0 2019-05-28 06:57:44

Check status from repmgr:
ID | Name | Role | Status | Upstream | Location | Priority | Connection string
----+-------+---------+-----------+----------+----------+----------+----------------------------------------------------------
1 | db1 | primary | - failed | | default | 100 | host=node1-sso-stage port=5432 user=repmgr dbname=repmgr
2 | db2 | primary | * running | | default | 100 | host=node2-sso-stage port=5432 user=repmgr dbname=repmgr

What's problem ?

t-ishii

2019-06-13 21:44

developer   ~0002653

Sorry for delay. I noticed:

1. You configure Pgpool-II as master/slave mode. Probably it's not what you want. You should configure Pgpool-II in streaming replication mode.

2. Both Pgpool-II and repmgr try to manage failover. It's not surprising that Pgpool-II does not work well with failover if someone else tries to manage it.

t-ishii

2019-08-15 16:56

developer   ~0002785

No response from the reporter over 1 month. Issue will be closed.

Issue History

Date Modified Username Field Change
2019-05-21 12:55 staslg New Issue
2019-05-21 13:25 t-ishii Assigned To => t-ishii
2019-05-21 13:25 t-ishii Status new => feedback
2019-05-21 13:28 t-ishii Note Added: 0002610
2019-05-21 13:50 staslg Note Added: 0002611
2019-05-21 13:50 staslg Status feedback => assigned
2019-05-21 14:08 t-ishii Status assigned => feedback
2019-05-23 14:03 staslg Note Added: 0002629
2019-05-23 14:03 staslg Status feedback => assigned
2019-05-23 14:08 t-ishii Status assigned => resolved
2019-05-28 13:13 staslg Status resolved => feedback
2019-05-28 13:13 staslg Resolution open => reopened
2019-05-28 13:13 staslg Note Added: 0002639
2019-06-13 21:44 t-ishii Note Added: 0002653
2019-08-15 16:56 t-ishii Note Added: 0002785